找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 957|回复: 0

[他山之石] How to find the Model Space Viewport View Directions

[复制链接]

已领礼包: 1268个

财富等级: 财源广进

发表于 2013-7-13 17:49:34 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
How to find the Model Space Viewport View Directions using Visual LISP in AutoCADby Fenton Webb
Someone asked how to obtain the Model Space Vports’ View Direction using LISP. I found it pretty tricky. I say tricky, because I actually was not able to find a clean solution (without toggling TILEMODE) – perhaps some of you LISP “Jedi masters” will know of a better way?
The problem is that, for performance reasons, the table which contains the View Direction data is only updated when you switch TILEMODE. Now in ObjectARX or .NET of course, you have full control when those tables will be updated (using acedVports2VportTableRecords) but for LISP it’s not so easy (unless, of course, you use .NET to expose a LispFunction which calls acedVports2VportTableRecords).
Anyway, here’s the LISP Code…
(defun c:vptest ()
   (vl-load-com) ; always make sure the COM system is loaded

   ; This is done to synchronize the viewports with the Viewport Table records
   ; In ObjectARX this is done with acedVports2VportTableRecords()  
   (setvar "tilemode" 0)
   (setvar "tilemode" 1)
  
  ;Get the Viewports collection
  (setq objAcad   (vlax-get-acad-object)
        objDoc    (vla-get-ActiveDocument objAcad)
        objVports (vla-get-viewports objDoc)
  )

  ; use a for loop and loop through the viewports
  (vlax-for objVport objVports

    ;(vlax-dump-object objVport)   ; Print out objects properties
    ; get the direction of the viewport
    (setq directionVariant (vla-get-direction objVport))
    (setq safArray (vlax-variant-value directionVariant))

    ; Get the x,y,z values of the direction
    ; this can be used to determine the view
    (setq x (vlax-safearray-get-element safArray 0))
    (print (strcat "X=" (rtos x)))
    (setq y (vlax-safearray-get-element safArray 1))
    (print (strcat "Y=" (rtos y)))
    (setq z (vlax-safearray-get-element safArray 2))
    (print (strcat "Z=" (rtos z)))

    ; this is a simple example of setting the active viewport
    ; if x equals zero then make this viewport the active viewport
    ; this test would need to be enhanced to test the y and z values
    ; y should equal zero and x should be 1 (that is WCS)
    (if (= x 0.0)
      (vla-put-activeviewport objDoc objVport)
    )   
  )

  (princ)
)



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-27 22:34 , Processed in 0.186405 second(s), 32 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表